#include "ieee1451_ncap.h"
#include "ieee1451_tim.h"
#include <utility/ostream.h>

__USING_SYS
OStream cout;


IEEE1451_NCAP *IEEE1451_NCAP::_ieee1451 = 0;

IEEE1451_NCAP::IEEE1451_NCAP() : _application(0), id_generator(1)
{
    //tim comunication
}

IEEE1451_NCAP::~IEEE1451_NCAP()
{
	//destrutor do tim comunication
}


unsigned short IEEE1451_NCAP::send_command(const std::string &destination, unsigned short channel_number,
                                           unsigned short command, const char *args, unsigned int length,
                                           bool multimedia)
{

switch (command)
{
	 case COMMAND_CLASS_READ_TEDS_SEGMENT:
        {            break;
        }
	case COMMAND_CLASS_READ_TRANSDUCER_CHANNEL_DATA_SET_SEGMENT:
        {
            unsigned int offset = *((unsigned int *) buffer);
            read_data_set(trans_id, offset);
            break;
        }
	case COMMAND_CLASS_TRANSDUCER_CHANNEL_OPERATE:
            cout<<"Comando start()\n";//start();
            break;

        case COMMAND_CLASS_TRANSDUCER_CHANNEL_IDLE:
            cout<<"Comando stop()\n"//stop();
            break;

        case COMMAND_CLASS_START_READ_TRANSDUCER_CHANNEL_DATA_SET_SEGMENT:
	    cout<<"start_read_data_set(trans_id)\n";
            //start_read_data_set(trans_id);
            break;

        case COMMAND_CLASS_STOP_READ_TRANSDUCER_CHANNEL_DATA_SET_SEGMENT:
	    cout<<"stop_read_data_set(trans_id)\n";
            //stop_read_data_set(trans_id);
            break;

        default:
            cout<< "IEEE1451_Transducer - Received invalid message\n";
            break;

}
}

void IEEE1451_NCAP::execute()
{
    cout << "IEEE1451_NCAP - Executing...\n";
/*
    char *p;
    IEEE1451_UART *uart = (IEEE1451_UART *) _receive_buffer;
    IEEE1451_Packet *packet = (IEEE1451_Packet *) (_receive_buffer + sizeof(IEEE1451_UART));
    char *msg = _receive_buffer + sizeof(IEEE1451_UART) + sizeof(IEEE1451_Packet);

    while (true)
    {
        p = _receive_buffer;

        for (unsigned short i = 0; i < sizeof(IEEE1451_UART); i++)
            *p++ = _uart.get();

        for (unsigned short i = 0; i < sizeof(IEEE1451_Packet); i++)
            *p++ = _uart.get();

        for (unsigned short i = 0; i < packet->_length; i++)
            *p++ = _uart.get();

        std::string address;
        ip_array2string(uart->_address, address);

        //std::cout << "IEEE1451_NCAP - Received (addr=" << address.c_str() << ", type=" << (short) uart->_type
        //          << ", id=" << packet->_trans_id << ", len=" << packet->_length << ")\n";

        if (uart->_type == PACKET_TYPE_CONNECT)
        {
            _application->report_tim_connected(address);

        }else if (uart->_type == PACKET_TYPE_DISCONNECT)
        {
            _application->report_tim_disconnected(address);

        }else if ((uart->_type == PACKET_TYPE_MESSAGE) || (uart->_type == PACKET_TYPE_MESSAGE_MULTIMEDIA))
        {
            if (packet->_length > 0)
            {
                if (packet->_trans_id == 0)
                    _application->report_tim_initiated_message(address, msg, packet->_length);
                else
                    _application->report_command_reply(address, packet->_trans_id, msg, packet->_length);
            }
        }else if (uart->_type == PACKET_TYPE_LOG)
        {
            msg[packet->_length] = 0;
            std::cout << "++ IEEE1451_Sink: " << msg << "\n";
        }
    }*/
}
