#include "ieee1451_objects.h"
#include "ieee1451_tim.h"
#include "utility/string.h"
#include "utility/list.h"

__BEGIN_SYS

struct IEEE1451_TEDS_NCAP
{
    IEEE1451_TEDS_NCAP(char id, const char *teds, unsigned short length, bool sub_block = false);
    ~IEEE1451_TEDS_NCAP() { delete _value; }

    char *get_tlv(char type);

    char _id;
    unsigned short _length;
    char *_value;
};


struct IEEE1451_Channel
{
    virtual ~IEEE1451_Channel();

    IEEE1451_TEDS_NCAP *get_teds(char id);
   // void add_teds(IEEE1451_TEDS_NCAP *teds) { _teds.push_back(teds); }

    //std:string _address;
    //List<IEEE1451_TEDS_NCAP *> _teds;
};


class IEEE1451_NCAP //IEEE 1451.0 + IEEE 1451.5
{
public:
    IEEE1451_NCAP();
    ~IEEE1451_NCAP();
    unsigned short send_command(unsigned short channel_number, unsigned short command,
                                const char *args = 0, unsigned int length = 0, bool multimedia = false);
    int execute();
private:
	IEEE1451_TIM tim;
	unsigned int id_generator;	
};
