// EPOS ATMega1281 Mediator Initialization

#include <machine.h>
#include <system.h>

extern "C" { void __epos_library_app_entry(void); }

__BEGIN_SYS

void ATMega1281::init()
{
    db<Init, ATMega1281>(TRC) << "ATMega1281::init()\n";

    System::info()->lmm.app_entry =
	reinterpret_cast<unsigned int>(&__epos_library_app_entry);

    IC::disable();

    AT86RF230::init();

    // Initialize the hardware
    if(Traits<ATMega1281_NIC>::enabled)
	ATMega1281_NIC::init();

    return;
}

__END_SYS

